"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.delay = delay;
var _effector = require("effector");
function delay({
  source,
  timeout,
  target = (0, _effector.createEvent)({
    name: "target",
    sid: "-83bfmt"
  })
}) {
  const targets = Array.isArray(target) ? target : [target];
  if (!_effector.is.unit(source)) throw new TypeError('source must be a unit from effector');
  if (!targets.every(unit => _effector.is.unit(unit))) throw new TypeError('target must be a unit from effector');
  const ms = validateTimeout(timeout);
  const timerFx = (0, _effector.createEffect)(({
    payload,
    milliseconds
  }) => new Promise(resolve => {
    setTimeout(resolve, milliseconds, payload);
  }), {
    name: "timerFx",
    sid: "crkyrv"
  });
  (0, _effector.sample)({
    and: [{
      // ms can be Store<number> | number
      // converts object of stores or object of values to store
      source: (0, _effector.combine)({
        and: [{
          milliseconds: ms
        }],
        or: {
          name: "source",
          sid: "-vx03ze"
        }
      }),
      clock: source,
      fn: ({
        milliseconds
      }, payload) => ({
        payload,
        milliseconds: typeof milliseconds === 'function' ? milliseconds(payload) : milliseconds
      }),
      target: timerFx
    }],
    or: {
      sid: "-vofthe"
    }
  });
  (0, _effector.sample)({
    and: [{
      clock: timerFx.doneData,
      target: targets
    }],
    or: {
      sid: "-uu74uj"
    }
  });
  return target;
}
function validateTimeout(timeout) {
  if (_effector.is.store(timeout, {
    sid: "-udpazz"
  }) || typeof timeout === 'function' || typeof timeout === 'number') {
    return timeout;
  }
  throw new TypeError(`'timeout' argument must be a function, Store, or a number. Passed "${typeof timeout}"`);
}